from flask import Flask, request
from flask import render_template
import os
import logging, json
import MainBotFunc

from BotData import ApiMainPassword

app = Flask(__name__)

def Error_decorator(func):
    def function(*args, **kwargs):
        try:
            return func(*args, **kwargs)
        except Exception as e:
            print(func.__name__, 'Exception: ', str(e))
            logging.error(func.__name__, 'Exception: ', str(e))
    return function

functions = {'deposit_address': MainBotFunc.deposit_address, 'get_coin_price': MainBotFunc.get_coin_price,
    'coin_price': MainBotFunc.coin_price , 'Threaded_download': MainBotFunc.Threaded_download,
    'Add_Watermark': MainBotFunc.Add_Watermark, 'reduse_image_size': MainBotFunc.reduse_image_size,
    'reduse_image_pixel_size': MainBotFunc.reduse_image_pixel_size,
    'convert_image_to_PDF': MainBotFunc.convert_image_to_PDF, 'convert_image_to_PDF_2': MainBotFunc.convert_image_to_PDF_2,
    'convert_multi_image_to_PDF': MainBotFunc.convert_multi_image_to_PDF, 'Audio_Time_Estimate': MainBotFunc.Audio_Time_Estimate,
    'SoundSplit': MainBotFunc.SoundSplit, 'get_random_joke': MainBotFunc.get_random_joke, 'Currency_rates': MainBotFunc.Currency_rates,
    'weather_daily': MainBotFunc.weather_daily, 'weather_current': MainBotFunc.weather_current, 'Get_random_comic': MainBotFunc.Get_random_comic,
    'Secure_PDF': MainBotFunc.Secure_PDF, 'combine_multi_pdf': MainBotFunc.combine_multi_pdf, 'Secure_Time_Estimate': MainBotFunc.Secure_Time_Estimate,
    'reduce_PDF_size': MainBotFunc.reduce_PDF_size, 'zip_extract': MainBotFunc.zip_extract, 'Log_to_Excel': MainBotFunc.Log_to_Excel,
    'Covid_Data': MainBotFunc.Covid_Data, 'get_json_kline': MainBotFunc.get_json_kline, 'get_coin_chart': MainBotFunc.get_coin_chart,
    'Get_ip_info': MainBotFunc.Get_ip_info, 'Class_Log_to_Excel': MainBotFunc.Class_Log_to_Excel
}

@app.route("/MainBotFunctions/api/<FunctionName>/<password>", methods=['GET', 'POST'])
@Error_decorator
def get_coin_price_api(FunctionName, password):
    if password == ApiMainPassword:
        kwargs = json.loads(request.data)
        return functions[FunctionName](**kwargs), 200
    else:
        return str('Forbiden'), 404


picFolder = os.path.join('static','pics')
app.config['UPLOAD_FOLDER'] = picFolder

@app.route('/')
def temp_page():
    pic1 = os.path.join(app.config['UPLOAD_FOLDER'], 'ai.jpeg')
    return render_template('template.html', user_pic=pic1)


@app.route('/temp')
def hello_world():
    return render_template('home.html')
    

    
if __name__ == "__main__":
    app.run()